---
title: URL API
slug: Web/API/URL_API
tags:
  - API
  - Address
  - Domain
  - Forms
  - Host
  - IP
  - Overview
  - URL
  - URL API
  - Web
  - hostname
---
<p>{{DefaultAPISidebar("URL API")}}</p>

<p><span class="seoSummary">The URL API is a component of the URL standard, which defines what constitutes a valid {{Glossary("URL", "Uniform Resource Locator")}} and the API that accesses and manipulates URLs.</span> The URL standard also defines concepts such as domains, hosts, and IP addresses, and also attempts to describe in a standard way the legacy <code>application/x-www-form-urlencoded</code> {{Glossary("MIME type")}} used to submit web forms' contents as a set of key/value pairs.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="URL_concepts_and_usage">URL concepts and usage</h2>

<p>The majority of the URL standard is taken up by the <a href="/en-US/docs/Learn/Common_questions/What_is_a_URL">definition of a URL</a> and how it is structured and parsed. Also covered are definitions of various terms related to addressing of computers on a network, and the algorithms for parsing IP addresses and DOM addresses are specified. More interesting to most developers is the API itself.</p>

<h3 id="Accessing_URL_components">Accessing URL components</h3>

<p>Creating an {{domxref("URL")}} object for a given URL parses the URL and provides quick access to its constituent parts through its properties.</p>

<pre class="brush: js notranslate">let addr = new URL("https://developer.mozilla.org/en-US/docs/Web/API/URL_API");
let host = addr.host;
let path = addr.pathname;
</pre>

<p>The snippet above creates a <code>URL</code> object for the article you're reading right now, then fetches the {{domxref("URL.host", "host")}} and {{domxref("URL.pathname", "pathname")}} properties. In this case, those strings are <code>developer.mozilla.org</code> and <code>/en-US/docs/Web/API/URL_API</code>, respectively.</p>

<h3 id="Changing_the_URL">Changing the URL</h3>

<p>Most of the properties of <code>URL</code> are settable; you can write new values to them to alter the URL represented by the object. For example, to create a URL and set its username:</p>

<pre class="brush: js notranslate">let myUsername = "someguy";
let addr = new URL("https://mysite.com/login");
addr.username = myUsername;
</pre>

<p>Setting the value of {{domxref("URL.username", "username")}} not only sets that property's value, but it updates the overall URL. After executing the code snippet above, the value returned by {{domxref("URL.href", "addr.href")}} is <code>https://someguy@mysite.com/login</code>. This is true for any of the writable properties.</p>

<h3 id="Queries">Queries</h3>

<p>The {{domxref("URL.search", "search")}} property on a <code>URL</code> contains the query string portion of the URL. For example, if the URL is <code>https://mysite.com/login?user=someguy&amp;page=news</code>, then the value of the <code>search</code> property is <code>?user=someguy&amp;page=news</code>. You can also look up the values of individual parameters with the {{domxref("URLSearchParams")}} object's {{domxref("URLSearchParams.get", "get()")}} method:</p>

<pre class="brush: js notranslate">let addr = new URL("https://mysite.com/login?user=someguy&amp;page=news");
try {
  loginUser(addr.searchParams.get("user"));
  gotoPage(addr.searchParams.get("page"));
} catch(err) {
  showErrorMessage(err);
}
</pre>

<p>For example, in the above snippet, the username and target page are taken from the query and passed to appropriate functions that are used by the site's code to log in and route the user to their desired destination within the site.</p>

<p>Other functions within <code>URLSearchParams</code> let you change the value of keys, add and delete keys and their values, and even sort the list of parameters.</p>

<h2 id="URL_API_interfaces">URL API interfaces</h2>

<p>The URL API is a simple one, with only a couple of interfaces to its name:</p>

<div class="index">
<ul>
 <li><span class="indexListRow"><span class="indexListTerm"><a href="/en-US/docs/Web/API/URL"><code>URL</code></a></span></span></li>
 <li><span class="indexListRow"><span class="indexListTerm"><a href="/en-US/docs/Web/API/URLSearchParams"><code>URLSearchParams</code></a></span></span></li>
</ul>
</div>

<p>Older versions of the specification included an interface called {{domxref("URLUtilsReadOnly")}}, which has since been merged into the {{domxref("WorkerLocation")}} interface.</p>

<h2 id="Examples">Examples</h2>

<p>If you want to process the parameters included in a URL, you could do it manually, but it's much easier to create a <code>URL</code> object to do it for you. The <code>fillTableWithParameters()</code> function below takes as input a {{domxref("HTMLTableElement")}} object representing a {{HTMLElement("table")}}. Rows are added to the table, one for each key found in the parameters, with the first column containing the key's name, and the second column having the value.</p>

<p>Note the call to {{domxref("URLSearchParams.sort()")}} to sort the parameter list before generating the table.</p>

<pre class="brush: js notranslate">function fillTableWithParameters(tbl) {
  let url = new URL(document.location.href);
  url.searchParams.sort();
  let keys = url.searchParams.keys();

  for (let key of keys) {
    let val = url.searchParams.get(key);
    let row = document.createElement("tr");
    let cell = document.createElement("td");
    cell.innerText = key;
    row.appendChild(cell);
    cell = document.createElement("td");
    cell.innerText = val;
    row.appendChild(cell);
    tbl.appendChild(row);
  };
}</pre>

<p>A working version of this example can be <a href="https://url-api.glitch.me">found on Glitch</a>. Just add parameters to the URL when loading the page to see them in the table. For instance, try <code><a href="https://url-api.glitch.me?from=mdn&amp;excitement=high&amp;likelihood=inconceivable">https://url-api.glitch.me?from=mdn&amp;excitement=high&amp;likelihood=inconceivable</a></code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('URL')}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>WHATWG specification</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.URL")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a></li>
 <li>CSS {{cssxref("&lt;url&gt;")}} type</li>
</ul>
